blob: 90a091b6ae4de74e6c070d77255b9f4b5655629a [file] [log] [blame]
Linus Torvalds1da177e2005-04-16 15:20:36 -07001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
Michal Marek1cba0c32015-04-08 11:11:57 +02005PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
Steven Rostedt281c9da2009-04-29 22:52:23 -04006 localmodconfig localyesconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -07007
Al Viro61bee202008-08-25 04:51:27 -04008ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
Arnaud Lacombe838a2e52010-09-04 17:10:20 -040011Kconfig := Kconfig
Al Viro61bee202008-08-25 04:51:27 -040012endif
Sam Ravnborge703f752007-10-25 20:42:18 +020013
Michal Marek0a1f00a2015-04-08 13:30:42 +020014ifeq ($(quiet),silent_)
15silent := -s
16endif
17
Yann E. MORINc2838e62012-11-22 01:06:04 +010018# We need this, in case the user has it in its environment
19unexport CONFIG_
20
Linus Torvalds1da177e2005-04-16 15:20:36 -070021xconfig: $(obj)/qconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020022 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070023
24gconfig: $(obj)/gconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020025 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070026
27menuconfig: $(obj)/mconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020028 $< $(silent) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070029
30config: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020031 $< $(silent) --oldaskconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070032
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020033nconfig: $(obj)/nconf
Michal Marek0a1f00a2015-04-08 13:30:42 +020034 $< $(silent) $(Kconfig)
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020035
Linus Torvalds1da177e2005-04-16 15:20:36 -070036silentoldconfig: $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090037 $(Q)mkdir -p include/config include/generated
Nicolas Pitred3fc4252016-11-30 17:41:58 -050038 $(Q)test -e include/generated/autoksyms.h || \
39 touch include/generated/autoksyms.h
Michal Marek0a1f00a2015-04-08 13:30:42 +020040 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070041
Arnaud Lacombe50bce3e2011-07-01 18:13:03 -040042localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090043 $(Q)mkdir -p include/config include/generated
Arnaud Lacombe22d550a2011-07-20 00:40:09 -040044 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
Michal Marek7a996d32010-08-04 14:05:07 +020045 $(Q)if [ -f .config ]; then \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020046 cmp -s .tmp.config .config || \
47 (mv -f .config .config.old.1; \
48 mv -f .tmp.config .config; \
Michal Marek0a1f00a2015-04-08 13:30:42 +020049 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020050 mv -f .config.old.1 .config.old) \
51 else \
52 mv -f .tmp.config .config; \
Michal Marek0a1f00a2015-04-08 13:30:42 +020053 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Steven Rostedta7c02602009-05-07 11:09:55 -040054 fi
Steven Rostedt03fa25d2009-04-29 22:52:22 -040055 $(Q)rm -f .tmp.config
56
EGRY Gabor10200262008-01-11 23:40:00 +010057# Create new linux.pot file
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020058# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
EGRY Gabor46d26312008-01-11 23:46:11 +010059update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Michal Marek0a1f00a2015-04-08 13:30:42 +020060 $(Q)$(kecho) " GEN config.pot"
Peter Foleya24a1b82011-04-26 18:13:05 -040061 $(Q)xgettext --default-domain=linux \
62 --add-comments --keyword=_ --keyword=N_ \
63 --from-code=UTF-8 \
64 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
65 --directory=$(srctree) --directory=$(objtree) \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020066 --output $(obj)/config.pot
67 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
Paul Bollefa0ad6572011-11-05 12:21:30 +010068 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
69 $(srctree)/arch/*/um/Kconfig`; \
EGRY Gabor10200262008-01-11 23:40:00 +010070 do \
Michal Marek0a1f00a2015-04-08 13:30:42 +020071 $(kecho) " GEN $$i"; \
Sam Ravnborg42175162008-04-25 21:15:41 +020072 $(obj)/kxgettext $$i \
EGRY Gabor10200262008-01-11 23:40:00 +010073 >> $(obj)/config.pot; \
74 done )
Michal Marek0a1f00a2015-04-08 13:30:42 +020075 $(Q)$(kecho) " GEN linux.pot"
EGRY Gabor10200262008-01-11 23:40:00 +010076 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020077 --output $(obj)/linux.pot
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020078 $(Q)rm -f $(obj)/config.pot
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -070079
Michal Marek1cba0c32015-04-08 11:11:57 +020080# These targets map 1:1 to the commandline options of 'conf'
81simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
82 alldefconfig randconfig listnewconfig olddefconfig
83PHONY += $(simple-targets)
Linus Torvalds1da177e2005-04-16 15:20:36 -070084
Michal Marek1cba0c32015-04-08 11:11:57 +020085$(simple-targets): $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020086 $< $(silent) --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070087
Michal Marek1cba0c32015-04-08 11:11:57 +020088PHONY += oldnoconfig savedefconfig defconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070089
Adam Leefb16d892012-09-01 01:05:17 +080090# oldnoconfig is an alias of olddefconfig, because people already are dependent
Diego Viola39c3f1b2015-05-31 14:35:51 -030091# on its behavior (sets new symbols to their default value but not 'n') with the
Adam Leefb16d892012-09-01 01:05:17 +080092# counter-intuitive name.
Michal Marek1cba0c32015-04-08 11:11:57 +020093oldnoconfig: olddefconfig
Adam Leefb16d892012-09-01 01:05:17 +080094
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020095savedefconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +020096 $< $(silent) --$@=defconfig $(Kconfig)
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020097
Linus Torvalds1da177e2005-04-16 15:20:36 -070098defconfig: $(obj)/conf
99ifeq ($(KBUILD_DEFCONFIG),)
Michal Marek0a1f00a2015-04-08 13:30:42 +0200100 $< $(silent) --defconfig $(Kconfig)
Jan Beulich42f9d3c2016-01-25 09:45:47 -0700101else
102ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
Michal Marek0a1f00a2015-04-08 13:30:42 +0200103 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
104 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Michael Ellermand2036f32015-09-23 15:40:34 +1000105else
106 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
107 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700108endif
Jan Beulich42f9d3c2016-01-25 09:45:47 -0700109endif
Linus Torvalds1da177e2005-04-16 15:20:36 -0700110
111%_defconfig: $(obj)/conf
Michal Marek0a1f00a2015-04-08 13:30:42 +0200112 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700113
Masahiro Yamada63a91032015-03-13 15:21:43 +0900114configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
Josh Triplett3aaefce2014-08-06 15:21:00 -0700115
Masahiro Yamada63a91032015-03-13 15:21:43 +0900116%.config: $(obj)/conf
117 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
118 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
119 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
Josh Triplett3aaefce2014-08-06 15:21:00 -0700120
121PHONY += kvmconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900122kvmconfig: kvm_guest.config
123 @:
Josh Triplett3aaefce2014-08-06 15:21:00 -0700124
Luis R. Rodriguez6c668502015-05-20 11:53:39 -0700125PHONY += xenconfig
126xenconfig: xen.config
127 @:
128
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700129PHONY += tinyconfig
Masahiro Yamada63a91032015-03-13 15:21:43 +0900130tinyconfig:
131 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700132
Linus Torvalds1da177e2005-04-16 15:20:36 -0700133# Help text used by make help
134help:
135 @echo ' config - Update current config utilising a line-oriented program'
Geert Uytterhoevenfa75a722015-05-26 13:39:54 +0200136 @echo ' nconfig - Update current config utilising a ncurses menu based'
137 @echo ' program'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700138 @echo ' menuconfig - Update current config utilising a menu based program'
Diego Viola092373c2015-04-06 06:27:45 -0300139 @echo ' xconfig - Update current config utilising a Qt based front-end'
Diego Viola39c3f1b2015-05-31 14:35:51 -0300140 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700141 @echo ' oldconfig - Update current config utilising a provided .config as base'
Steven Rostedt03fa25d2009-04-29 22:52:22 -0400142 @echo ' localmodconfig - Update current config disabling modules not loaded'
Steven Rostedt281c9da2009-04-29 22:52:23 -0400143 @echo ' localyesconfig - Update current config converting local mods to core'
Markus Heidelberg590a5852009-05-18 01:36:46 +0200144 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200145 @echo ' defconfig - New config with default from ARCH supplied defconfig'
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200146 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
Jesper Juhle11f0492006-02-25 21:52:50 +0100147 @echo ' allnoconfig - New config where all options are answered with no'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200148 @echo ' allyesconfig - New config where all options are accepted with yes'
149 @echo ' allmodconfig - New config selecting modules when possible'
150 @echo ' alldefconfig - New config with all symbols set to default'
151 @echo ' randconfig - New config with random answer to all options'
Sam Ravnborg861b4ea2010-07-31 23:35:28 +0200152 @echo ' listnewconfig - List new options'
Geert Uytterhoevenfa75a722015-05-26 13:39:54 +0200153 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
154 @echo ' default value'
Luis R. Rodriguez9bcd7762015-05-20 11:53:38 -0700155 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
Luis R. Rodriguez6c668502015-05-20 11:53:39 -0700156 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700157 @echo ' tinyconfig - Configure the tiniest possible kernel'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700158
Sam Ravnborg2982de62006-07-27 22:10:27 +0200159# lxdialog stuff
160check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
161
Rob Landleye9e40e12007-10-15 19:23:12 -0500162# Use recursively expanded variables so we do not call gcc unless
Sam Ravnborg2982de62006-07-27 22:10:27 +0200163# we really need to do so. (Do not call gcc as part of make mrproper)
Arnaud Lacombe9ba95682010-08-22 20:03:06 -0400164HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
165 -DLOCALE
Sam Ravnborg2982de62006-07-27 22:10:27 +0200166
Linus Torvalds1da177e2005-04-16 15:20:36 -0700167# ===========================================================================
168# Shared Makefile for the various kconfig executables:
169# conf: Used for defconfig, oldconfig and related targets
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200170# nconf: Used for the nconfig target.
171# Utilizes ncurses
Markus Heidelberg6f26e5e2009-05-18 01:36:45 +0200172# mconf: Used for the menuconfig target
Linus Torvalds1da177e2005-04-16 15:20:36 -0700173# Utilizes the lxdialog package
174# qconf: Used for the xconfig target
Diego Viola092373c2015-04-06 06:27:45 -0300175# Based on Qt which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700176# gconf: Used for the gconfig target
Diego Viola39c3f1b2015-05-31 14:35:51 -0300177# Based on GTK+ which needs to be installed to compile it
Linus Torvalds1da177e2005-04-16 15:20:36 -0700178# object files used by all kconfig flavours
179
Sam Ravnborg2982de62006-07-27 22:10:27 +0200180lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
181lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
182
Linus Torvalds1da177e2005-04-16 15:20:36 -0700183conf-objs := conf.o zconf.tab.o
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200184mconf-objs := mconf.o zconf.tab.o $(lxdialog)
185nconf-objs := nconf.o zconf.tab.o nconf.gui.o
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -0700186kxgettext-objs := kxgettext.o zconf.tab.o
Peter Foleyf1943042011-04-26 18:00:05 -0400187qconf-cxxobjs := qconf.o
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400188qconf-objs := zconf.tab.o
189gconf-objs := gconf.o zconf.tab.o
Linus Torvalds1da177e2005-04-16 15:20:36 -0700190
Masahiro Yamada022af622014-08-19 16:34:22 +0900191hostprogs-y := conf nconf mconf kxgettext qconf gconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700192
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400193clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400194clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
EGRY Gabor10200262008-01-11 23:40:00 +0100195clean-files += config.pot linux.pot
Linus Torvalds1da177e2005-04-16 15:20:36 -0700196
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100197# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
198PHONY += $(obj)/dochecklxdialog
199$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
200$(obj)/dochecklxdialog:
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400201 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100202
203always := dochecklxdialog
204
Sam Ravnborgaa1e5ef2007-08-12 23:15:44 +0200205# Add environment specific flags
206HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
Yuri Vasilevski70a6a0c2005-10-30 15:03:20 -0800207
Linus Torvalds1da177e2005-04-16 15:20:36 -0700208# generated files seem to need this to find local include files
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400209HOSTCFLAGS_zconf.lex.o := -I$(src)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700210HOSTCFLAGS_zconf.tab.o := -I$(src)
211
Arnaud Lacombe378dbb22011-05-23 02:08:52 -0400212LEX_PREFIX_zconf := zconf
213YACC_PREFIX_zconf := zconf
214
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400215HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
216HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700217
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400218HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
Adrian Bunk37193142006-01-02 11:25:30 +0100219HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
Arnaud Lacombe1ea3ad42011-06-05 23:36:05 -0400220 -Wno-missing-prototypes
Linus Torvalds1da177e2005-04-16 15:20:36 -0700221
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400222HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
223
Justin Lecher544e7e52013-03-06 14:02:02 +0100224HOSTLOADLIBES_nconf = $(shell \
Brian Norris72859962014-06-04 00:52:31 -0700225 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
226 || pkg-config --libs menu panel ncurses 2>/dev/null \
Justin Lecher544e7e52013-03-06 14:02:02 +0100227 || echo "-lmenu -lpanel -lncurses" )
Linus Torvalds1da177e2005-04-16 15:20:36 -0700228$(obj)/qconf.o: $(obj)/.tmp_qtcheck
229
Masahiro Yamada022af622014-08-19 16:34:22 +0900230ifeq ($(MAKECMDGOALS),xconfig)
Roman Zippelb3a52252005-11-21 21:32:38 -0800231$(obj)/.tmp_qtcheck: $(src)/Makefile
Linus Torvalds1da177e2005-04-16 15:20:36 -0700232-include $(obj)/.tmp_qtcheck
233
Diego Viola092373c2015-04-06 06:27:45 -0300234# Qt needs some extra effort...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700235$(obj)/.tmp_qtcheck:
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700236 @set -e; $(kecho) " CHECK qt"; \
Thiago Macieira588446a2015-11-01 21:12:53 -0600237 if pkg-config --exists Qt5Core; then \
238 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
239 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
240 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
241 elif pkg-config --exists QtCore; then \
242 cflags=`pkg-config --cflags QtCore QtGui`; \
243 libs=`pkg-config --libs QtCore QtGui`; \
244 moc=`pkg-config --variable=moc_location QtCore`; \
Sam Ravnborgab919c02005-11-06 11:05:21 +0100245 else \
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700246 echo >&2 "*"; \
Thiago Macieira588446a2015-11-01 21:12:53 -0600247 echo >&2 "* Could not find Qt via pkg-config."; \
248 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
Thiago Macieirad1b0dc92015-09-22 11:36:39 -0700249 echo >&2 "*"; \
250 exit 1; \
Roman Zippelb3a52252005-11-21 21:32:38 -0800251 fi; \
252 echo "KC_QT_CFLAGS=$$cflags" > $@; \
253 echo "KC_QT_LIBS=$$libs" >> $@; \
254 echo "KC_QT_MOC=$$moc" >> $@
Linus Torvalds1da177e2005-04-16 15:20:36 -0700255endif
256
257$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
258
Masahiro Yamada022af622014-08-19 16:34:22 +0900259ifeq ($(MAKECMDGOALS),gconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700260-include $(obj)/.tmp_gtkcheck
261
Diego Viola39c3f1b2015-05-31 14:35:51 -0300262# GTK+ needs some extra effort, too...
Linus Torvalds1da177e2005-04-16 15:20:36 -0700263$(obj)/.tmp_gtkcheck:
Adrian Bunk37193142006-01-02 11:25:30 +0100264 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
265 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700266 touch $@; \
267 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200268 echo >&2 "*"; \
269 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
270 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700271 false; \
272 fi \
273 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200274 echo >&2 "*"; \
275 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
276 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
277 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
278 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700279 false; \
280 fi
281endif
282
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400283$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
Linus Torvalds1da177e2005-04-16 15:20:36 -0700284
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400285$(obj)/qconf.o: $(obj)/qconf.moc
Linus Torvalds1da177e2005-04-16 15:20:36 -0700286
Yaakov Selkowitzebca0262012-07-04 18:31:11 -0500287quiet_cmd_moc = MOC $@
288 cmd_moc = $(KC_QT_MOC) -i $< -o $@
289
290$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
291 $(call cmd,moc)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700292
Diego Viola39c3f1b2015-05-31 14:35:51 -0300293# Extract gconf menu items for i18n support
EGRY Gabor46d26312008-01-11 23:46:11 +0100294$(obj)/gconf.glade.h: $(obj)/gconf.glade
Peter Foley2d80eb02011-04-26 18:16:53 -0400295 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
Peter Foleya24a1b82011-04-26 18:13:05 -0400296 $(obj)/gconf.glade